/*
 * Samples from the book: BizTalk Server 2000: A Beginner's Guide.
 * ISBN: 0-07-219011-6, published by Osborne/McGraw-Hill
 *
 * (c) 2000,2001 by Clemens F. Vasters. All rights reserved.
 *
 * This source code is intended only as a supplement to the book
 * "BizTalk Server 2000: A Beginner's Guide". The source code
 * may only be used for self-study, educational purposes in 
 * conjunction with a purchased, orginal copy of this book. You must 
 * not license, sell, rent, lease or redistribute this source code or 
 * derivatives thereof and you must not incorporate this source code 
 * or derivatives thereof in commercial or non-commercial software 
 * components or applications, independent of whether they are used 
 * within your own organization or the organization of your employer 
 * or are sold, licensed, rented, leased or otherwise distributed 
 * or disclosed to third parties.
 * 
 * Any use except self-study, educational purposes in conjunction 
 * with a purchased copy of this book requires written permission and, 
 * depending on the intended use, may require a commercial license 
 * from the author.
 *
 * The author can be contacted by email at clemensv@newtelligence.com
 *  
 * THIS CODE AND INFORMATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY
 * KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
 * PARTICULAR PURPOSE. 
 *
 * Project:  PipelineAIC
 * Filename: PipelineComp.h
 * 
 */

#ifndef __PIPELINECOMP_H_
#define __PIPELINECOMP_H_

#include "resource.h"       // main symbols
#include <bts_sdk_guids.h>
#include <commerce.h>

/////////////////////////////////////////////////////////////////////////////
// CPipelineComp
class ATL_NO_VTABLE CPipelineComp : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CPipelineComp, &CLSID_PipelineComp>,
	public ISupportErrorInfo,
	public IDispatchImpl<IPipelineComponent,&IID_IPipelineComponent, &LIBID_PIPELINEAICLib>,
	public IDispatchImpl<IPipelineComponentAdmin, &IID_IPipelineComponentAdmin, &LIBID_PIPELINEAICLib>,
	public IDispatchImpl<IPipelineComponentDescription, &IID_IPipelineComponentDescription, &LIBID_PIPELINEAICLib>,
	public IDispatchImpl<ISpecifyPipelineComponentUI, &IID_ISpecifyPipelineComponentUI, &LIBID_PIPELINEAICLib>,
	public IPersistStreamInit
{
public:
	CComQIPtr<IDictionary> dictConfig;
public:
	CPipelineComp();
	CComQIPtr<IErrorInfo> ReportError(UINT error);
	CComQIPtr<IErrorInfo> ReportWin32Error(UINT error);


DECLARE_REGISTRY_RESOURCEID(IDR_PIPELINECOMP)

DECLARE_PROTECT_FINAL_CONSTRUCT()
 
BEGIN_COM_MAP(CPipelineComp)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IPipelineComponent)
	COM_INTERFACE_ENTRY(IPipelineComponentAdmin)
	COM_INTERFACE_ENTRY(IPipelineComponentDescription)
	COM_INTERFACE_ENTRY(ISpecifyPipelineComponentUI)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY(IPersist)
END_COM_MAP()

BEGIN_CATEGORY_MAP(CPipelineComp)
    IMPLEMENTED_CATEGORY(CATID_BIZTALK_COMPONENT)
	IMPLEMENTED_CATEGORY(CATID_BIZTALK_AIC)
END_CATEGORY_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);


public:
// IPipelineComponent
	STDMETHOD(Execute)(IDispatch * pdispOrder, IDispatch * pdispContext, LONG lFlags, LONG * plErrorLevel);
	STDMETHOD(EnableDesign)(BOOL fEnable);
// IPipelineComponentAdmin
	STDMETHOD(GetConfigData)(IDispatch * * ppDict);
	STDMETHOD(SetConfigData)(IDispatch * pDict);
// IPipelineComponentDescription
	STDMETHOD(ValuesRead)(VARIANT * pvar);
	STDMETHOD(ValuesWritten)(VARIANT * pvar);
	STDMETHOD(ContextValuesRead)(VARIANT * pvar);
// ISpecifyPipelineComponentUI
	STDMETHOD(GetPipelineComponentUIProgID)(BSTR * pbstrProgID);
// IPersist
	STDMETHOD(GetClassID)(GUID * pClassID);
// IPersistStreamInit
	STDMETHOD(IsDirty)();
	STDMETHOD(Load)(IStream * pstm);
	STDMETHOD(Save)(IStream * pstm, BOOL fClearDirty);
	STDMETHOD(GetSizeMax)(_ULARGE_INTEGER * pCbSize);
	STDMETHOD(InitNew)();

};

#endif //__PIPELINECOMP_H_
