

' Force explicit declaration of all variables.
Option Explicit


On Error Resume Next

'---------------------------------------------------------------------------------

Dim strPath

strPath = WScript.ScriptFullName
strPath = Mid(strPath, 1, InStrRev(strPath, "\"))

Call ASTCreateVirtualWebDir("DocSpecs","BTSABG","Specifications")
Call ASTCreateVirtualWebDir("Maps","BTSABG","Maps")


'---------------------------------------------------------------------------------


Sub ASTCreateVirtualWebDir(SubDir, DirName, RelPath)
	Dim Computer, webSite, WebSiteID, vRoot, vDir, vDRoot
	On Error Resume Next
	
	set webSite = findWeb("localhost", "Default Web Site")
        if not IsObject(WebSite) then
           set webSite = findWeb("localhost", "Standardwebsite")
        end if 
	if IsObject(webSite) then
 		set vRoot = webSite.GetObject("IIsWebVirtualDir","Root")
		set vRoot = vRoot.GetObject("IIsWebVirtualDir","BizTalkServerRepository")
                Set vDRoot = vRoot.GetObject("IIsWebDirectory",SubDir)
                If Not IsObject(vDRoot) Then
  		   Set vDRoot = vRoot.Create("IIsWebDirectory",SubDir)
                End If 
                
		
		If Not IsObject(vDRoot) Then
			Display "Unable to access root for local default web site" 
		Else
			'Create the new virtual directory
			
			Set vDir = vDRoot.Create("IIsWebVirtualDir",DirName)
			If IsObject(vDir) Then
				'Set the new virtual directory path
				vDir.AccessRead = true
				vDir.AccessWrite = true
				vDir.AccessScript = true
				vDir.Path = strPath & RelPath
				'Save the changes
				vDir.SetInfo
			End If
			Err = 0
		
		End If
	else
		Display "Unable to find Default Web Site on localhost"
	End if
End Sub

Sub Display(Msg)
	WScript.Echo Now & ". Error Code: " & Hex(Err) & " - " & Msg
End Sub

Sub Trace(Msg)
	WScript.Echo Now & " : " & Msg	
End Sub

function getBinding(bindstr)

	Dim one, two, ia, ip, hn
	
	one=Instr(bindstr,":")
	two=Instr((one+1),bindstr,":")
	
	ia=Mid(bindstr,1,(one-1))
	ip=Mid(bindstr,(one+1),((two-one)-1))
	hn=Mid(bindstr,(two+1))
	
	getBinding=Array(ia,ip,hn)
end function

Function findWeb(computer, webname)
	On Error Resume Next

	Dim websvc, site
	dim webinfo
	Dim aBinding, binding

	set websvc = GetObject("IIS://"&computer&"/W3svc")
	if (Err <> 0) then
		exit function
	end if
	' First try to open the webname.
	set site = websvc.GetObject("IIsWebServer", webname)
	if (Err = 0) and (not isNull(site)) then
		if (site.class = "IIsWebServer") then
			' Here we found a site that is a web server.
			set findWeb = site
			exit function
		end if
	end if
	err.clear
	for each site in websvc
		if site.class = "IIsWebServer" then
			'
			' First, check to see if the ServerComment
			' matches
			'
			If site.ServerComment = webname Then
				set findWeb = site
				exit function
			End If
			aBinding=site.ServerBindings
			if (IsArray(aBinding)) then
				if aBinding(0) = "" then
					binding = Null
				else
					binding = getBinding(aBinding(0))
				end if
			else 
				if aBinding = "" then
					binding = Null
				else
					binding = getBinding(aBinding)
				end if
			end if
			if IsArray(binding) then
				if (binding(2) = webname) or (binding(0) = webname) then
					set findWeb = site
					exit function
				End If
			end if 
		end if
	next
End Function
